"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useBrix = void 0;

var _react = require("react");

var _BrixProvider = require("./BrixProvider");

var _helpers = require("./helpers");

var useBrix = function useBrix(path, notSetValue) {
  var state, setBrixState;

  try {
    var context = (0, _react.useContext)((0, _BrixProvider.getBrixContext)());
    state = context.state;
    setBrixState = context.setBrixState;
  } catch (err) {
    throw new Error('BrixProvider is not configured correctly in the app');
  }

  var value = state.getIn(path, notSetValue);

  var set = function set(updatedValue) {
    setBrixState(function (current) {
      return current.setIn(path, (0, _helpers.coerceDataToImmutable)(updatedValue));
    });
  };

  return [value, set];
};

exports.useBrix = useBrix;