"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getKey = exports.useWorker = void 0;
var index = 0;
var cache = {};
var BRIX_WORKER_RESULT = '___WORKER_RESULT__!';

var useWorker = function useWorker(key, worker) {
  if (cache[key]) {
    var workedItem = cache[key];

    if (workedItem.error) {
      throw workedItem.error;
    }

    if (workedItem.result !== BRIX_WORKER_RESULT) {
      return workedItem.result;
    }

    throw workedItem.worker;
  } else {
    var _workedItem = {
      result: BRIX_WORKER_RESULT,
      worker: worker().then(function (response) {
        _workedItem.result = response;
        return response;
      }, function (rejection) {
        console.log('rejected', rejection);
        _workedItem.error = rejection;
      }).catch(function (err) {
        _workedItem.error = err;
        console.log('caught', err);
      })
    };
    cache[key] = _workedItem;
    throw _workedItem.worker;
  }
};

exports.useWorker = useWorker;

var getKey = function getKey() {
  return "_key".concat(index++);
};

exports.getKey = getKey;